<i18n lang="yml">
  en:
    ranking: "Ranking"
    ranking_old: "Previous rank"
    ranking_new: "New rank"
    cluster_location: "Container location"
    odk: "ODK"
    odk_b: "%B"
    odk_scans: "[scans]"
    crow: "CROW"
    crow_b: "%B"
    crow_observed: "[schouw]"
  nl:
    ranking: "Rang"
    ranking_old: "Vorige rang"
    ranking_new: "Nieuwe rang"
    cluster_location: "Containerlocatie"
    odk_scans: "[scans]"
    crow_observed: "[schouw]"
</i18n>

<template>
  <AmsTableGroup :class="$style['toploc-tbody']">
    <template v-if="STATE.loaded.topLoc75">
      <template v-for="(row, rIndex) of rows">
        <AmsTableRow
          :key="rIndex"
          :is-actionable="true"
          :has-shadow="true"
          :is-active="STATE.filters.valueFor.cluster_location === row.cluster_location.value"
          :data-id="row.cluster_location.valueId"
          tabindex="0"
          @keydown.enter.native="inspectContainerCluster(row.cluster_location.value, $event)"
          @keydown.space.native="inspectContainerCluster(row.cluster_location.value, $event)"
          @click.capture.native="inspectContainerCluster(row.cluster_location.value, $event)"
        >
          <!-- Content cells -->
          <template v-for="(cell, cIndex) of Object.values(row).filter(cell => typeof cell.id !== 'undefined')">
            <AmsTableCell
              v-show="!cell.isHidden"
              :key="cIndex"
              :ref="cell.id"
              :tag="cIndex === 0 ? 'th' : 'td'"
              :class="$style[`cell-${cell.id}`]"
              :style="cell.style"
            >
              <div
                :class="[
                  $style['content'],
                  $style[cell.id],
                  'relative',
                ]"
              >
                <span :title="`${$t(cell.id)}: ${$t(cell.value)}`">
                  <template v-if="cell.value && cell.id === 'ranking_old'">
                    {{ `${$t(cell.prefix)}${rIndex + 1}${$t(cell.suffix)}` }}
                  </template>
                  <template v-else>
                    {{ `${$t(cell.prefix)}${cell.value === 0 ? cell.value : $t(cell.value)}${$t(cell.suffix)}` }}
                  </template>
                </span>
                <AmsProgressBar
                  v-if="cell.showProgressBar"
                  :progress="cell.value"
                />
              </div>
            </AmsTableCell>
          </template>
        </AmsTableRow>

        <!-- Empty rows for layout purposes as `tr` elements cannot have margin's. -->
        <AmsTableRow
          :key="`empty_row_${rIndex}x`"
          :empty="true"
        >
          <td :colspan="numberOfCells" />
        </AmsTableRow>
      </template>
    </template>

    <!-- Loading rows indicators -->
    <template v-else>
      <template v-for="row of 10">
        <AmsTableRowLoading :key="row" />
        <AmsTableRow :key="`empty_${row}`" :empty="true">
          <AmsTableCell style="padding: 0;" />
        </AmsTableRow>
      </template>
    </template>
  </AmsTableGroup>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  inject,
} from "@nuxtjs/composition-api";

export default defineComponent({
  name: "AmsScansTable",

  components: {
    AmsTableGroup: () => import("~/components/_elements/Table/TableGroup.vue"),
    AmsTableRow: () => import("~/components/_elements/Table/TableRow.vue"),
    AmsTableRowLoading: () => import("~/components/_elements/Table/TableRowLoading.vue"),
    AmsTableCell: () => import("~/components/_elements/Table/TableCell.vue"),
    AmsProgressBar: () => import("~/components/_elements/Indicators/ProgressBar.vue"),
  },

  props: {
    rows: {
      type: Array,
      default: () => [],
    },
  },

  setup (props) {
    const { STATE } = inject("store");

    const numberOfCells = computed(() => Object.keys(props.rows[0]).length);

    function inspectContainerCluster (clusterLocation, $event) {
      $event.preventDefault();

      if (STATE.filters.valueFor.cluster_location === clusterLocation) {
        STATE.filters.valueFor.cluster_location = "";
        // @ts-ignore
        document.activeElement.blur();
      } else {
        STATE.filters.valueFor.cluster_location = clusterLocation || "";
      }
    }

    return {
      STATE,
      numberOfCells,
      inspectContainerCluster,
    };
  },
});
</script>

<style lang="postcss" module>
.toploc-tbody {
  transition: height 500ms ease-out;

  th,
  td {
    &.cell-ranking_old {
      width: 3rem;

      @apply p-0;

      .content {
        margin-right: 5px;
        height: calc(3rem + 2px);
        font-size: 0.95em;

        @apply p-0 bg-gray-150 text-gray-400;

        &::after {
          content: "";

          @apply block relative bottom-0 left-0 w-full h-2 bg-gray-150;
        }

        & > span {
          @apply flex justify-center items-center w-full h-full;
        }
      }
    }

    &.cell-ranking_new {
      width: 3rem;

      @apply font-medium;
    }

    &.cell-cluster_location {
      width: calc(100% - 48% - 6rem);
      min-width: 6rem;

      @apply font-medium;

      .content {
        text-overflow: ellipsis;
        white-space: nowrap;

        @apply block overflow-hidden;

        & > span {
          @apply inline w-full;
        }
      }
    }

    &.cell-odk_b,
    &.cell-crow_b,
    &.cell-odk_scans,
    &.cell-crow_observed {
      width: 12.5%;
      min-width: 5rem;

      @apply leading-snug;

      .content {
        width: min-content;
      }
    }

    &:first-of-type {
      @apply rounded-l-sm;
    }

    &:last-of-type {
      @apply rounded-r-sm;
    }

    .content {
      @apply block py-2 h-8;

      & > span {
        @apply inline-flex w-full;
      }
    }
  }
}

.icon {
  transition: transform 250ms ease;

  @apply flex justify-center items-center;

  svg {
    width: 14px;
    height: 14px;
  }
}
</style>
